//+------------------------------------------------------------------+
//|                                                       Simone.mq4 |
//|                                  Copyright  2009, Steve Hopwood |
//|                              http://www.hopwood3.freeserve.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#property show_inputs
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define monthly "Monthly"
#define weekly "Weekly"
#define daily "Daily"
#define intraday "Intraday"
#define breech "Breech"
#define up "Up"
#define down "Down"
#define ranging "Ranging"
#define long "Long"
#define short "Short"
#define intradayhigh " Simone Intraday high "
#define intradaylow " Simone Intraday low "
#define breechhigh " Simone Breech high "
#define breechlow " Simone Breech low "
#define  upbutuntradable  "Up, but untradable"
#define  downbutuntradable "Down, but untradable"
#define  undecided "No trend yet"
#define intradayhigh 		" Simone Intraday high "
#define intradaylow		 	" Simone Intraday low "
#define intradayhightime 	" Simone Intraday high time "
#define intradaylowtime 	" Simone Intraday low time "
#define breechhigh 			" Simone Breech high "
#define breechlow 			" Simone Breech low "
#define breechhightime 		" Simone Breech high time "
#define breechlowtime 		" Simone Breech low time "
#define upbutuntradable  	"Up, but untradable"
#define downbutuntradable 	"Down, but untradable"
#define undecided 			"No trend yet"
#define FibObjDel 			1
#define FibObjSav 			0

/*

Simone's preferred pairs: eu, ej, gu


start()
void DisplayUserFeedback()

----Fibs/hi-lo/trend----
void DrawFib(string Name, color col)
void CalculateAndDrawBreech(bool BreechMustLeadMarket)
double GetPreviousHigh(double CurrentHigh, int& CurrentHighTime)
double GetPreviousLow(double CurrentLow, int& CurrentLowTime)
void GetHtfTrend()


----Trading----
bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
bool IsTargetReached()
bool GetBreechPivotCandlesClose(string direction, double target)


----Trade management----
void GetPosition()
bool UpdateStopLosses()
void HalfCloseAndMoveToBreakeven()
void AdjustTakeProfit()


*/
extern string  gi="____General inputs----";
extern double  Lot=0.02;
extern bool    StopTrading=false;//Allows user to use the robot to draw the fibs but not send trades
extern bool    TradeLong=true;
extern bool    TradeShort=true;
extern int     MagicNumber=0;
extern string  TradeComment="";
extern bool    CriminalIsECN=false;
extern bool    AlertNotTrade=false;
extern int     MinPipsBetweenTrades=200;
extern int     SlPipsFromBreech=200;
extern int     BreechPivotBreaksToTrade=2;
extern int     MaxStopLoss=700;
extern int     MaxTakeProfit=700;
extern string  fi="----Fib inputs----";
extern int		BarsPerFibDisplay = 4;		
extern string  mf="Monthly";
extern bool    DrawMonthly=true;
extern color   MonthlyFibColour=Blue;
extern string  wf="Weekly";
extern bool    DrawWeekly=true;
extern color   WeekFibColour=GreenYellow;
extern string  df="Daily";
extern bool    DrawDaily=true;
extern color   DailyFibColour=Green;
extern string  idf="Intraday";
extern bool    DrawIntraday=true;
extern color   IntradayFibColour=Turquoise;
extern int     MinIntradayFibSize=500;
extern string  brf="50% Breech fib";
extern int     MinPivotDifferenceAfterUpdate=200;
extern bool    DrawBreech=true;
extern color   BreechFibColour=Yellow;
extern string  tt="----Trading hours----";
extern string  Trade_Hours= "Set Morning & Evening Hours";
extern string  Trade_Hoursi= "Use 24 hour, local time clock";
extern string  Trade_Hours_M= "Morning Hours 0-12";
extern  int    start_hourm = 7;
extern  int    end_hourm = 12;
extern string  Trade_Hours_E= "Evening Hours 12-24";
extern  int    start_houre = 12;
extern  int    end_houre = 18;
extern string  hci="----Half-close inputs----";   
extern bool    AllowHalfClose=true;
extern double  PercentToClose=50;
extern int     BEP = 20;
extern string  stpp="---Stop trading at x% of balance profit----";
extern bool    StopTradingOnceTargetReached=False;
extern double  TargetPercentageOfBalance=5;
extern string  tf="----Trend filter----";
extern bool    UseRsiTrendFilter=false;
extern int     RsiPeriod=21;
extern int     RsiTimeFrame=1440;
extern int     RsiMaxContraMoveAllowed=5;
extern string  mst="----Manual trend setting----";
extern bool    SetTrendManually=False;
extern bool    TrendIsUp=false;
extern bool    TrendIsDown=false;
extern bool    TrendIsRanging=false;
extern string  mis="----Odds and ends----";
extern bool    ShowScreenFeedback=true;
extern int     DisplayGapSize=250;
   

//Fib variables
double         IntradayFibHigh, IntradayFibLow, IntradayPivot;//Holds current hi-lo of the fib
double         BreechFibHigh, BreechFibLow, BreechPivot;
string         Trend, HtfTrend;
int            TakeProfitsPipTolerance = 50;
string         IntradayHighGv, IntradayLowGv, BreechHighGv, BreechLowGv;
int	         IntradayFibHighTime, IntradayFibLowTime, BreechFibHighTime, BreechFibLowTime; 										
string         IntradayHighTimeGv, IntradayLowTimeGv, BreechHighTimeGv, BreechLowTimeGv; 												
double 			StaticFibLevels[] = { -0.55, -0.34, 0.0, 0.191, 0.382, 0.5, 0.618, 0.809, 1.0, 1.34, 1.55 }; 					
string			StaticFibDesc[]   = { "T2  (-55) ", "T1  (-34) ", "Lw    (0) ", "S1 (19.1) ", "S  (38.2) ", "Pvt  (50) ",  	
                                     "B  (61.8) ", "R1 (80.9) ", "Hi  (100) ", "T1  (134) ", "T2  (155) " };  					
//Misc
//int            OldDailyBars, OldBars; 
int            OldBars; 
double         StopLoss, TakeProfit;
int            NoOfTrades;
int            TicketNo;//Holds the ticket number of the most recent open trade eg the last in a sequence of 3
int            TicketNumbers[];//Holds an array of open trade ticket numbers
bool           RobotDisabled;
string         Gap, DisabledMessage, ScreenMessage;

#include <simone stuff.mqh>//grandehombre's library for preserving user's mn and trading times

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----
   

   
   
   firstTime= true;
      
   FiboObjectDelete(monthly); // KH MOD
   FiboObjectDelete(weekly); // KH MOD
   FiboObjectDelete(daily); // KH MOD
   FiboObjectDelete(intraday); // KH MOD
   FiboObjectDelete(breech); // KH MOD

   if (Digits == 2 || Digits == 4)
   {
      TakeProfitsPipTolerance/= 10;
      MinPivotDifferenceAfterUpdate/= 10;
      MinPipsBetweenTrades/= 10;
      BEP/= 10;
      MinIntradayFibSize/= 10;
      SlPipsFromBreech/= 10;
      MaxStopLoss/= 10;
      MaxTakeProfit/= 10;
   }//if (Digits == 2 || Digits == 4)
   
   //Set up globals to allow robot to pick up in case of reinitialisation
   IntradayHighGv 		= Symbol() + intradayhigh;
   IntradayLowGv 			= Symbol() + intradaylow;
   BreechHighGv 			= Symbol() + breechhigh;
   BreechLowGv 			= Symbol() + breechlow;
   IntradayHighTimeGv 	= Symbol() + intradayhightime; 
   IntradayLowTimeGv 	= Symbol() + intradaylowtime; 
   BreechHighTimeGv 		= Symbol() + breechhightime; 
   BreechLowTimeGv 		= Symbol() + breechlowtime; 
   
//   OldDailyBars = 0; // KH Mod
   OldBars = Bars;//Force the robot to wait for a new candle before looking for a trade
   
   //ObjectsDeleteAll(); // KH Mod
   
//----
   Gap="";
   if (DisplayGapSize >0)
   {
      for (int cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }//if (DisplayGapSize >0)
   start();
   return(0);
}

void DisplayUserFeedback()
{
      ScreenMessage = "";
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
      //Code for time to bar-end display from Candle Time by Nick Bilak
      double i;
      int m,s,k;
      m=Time[0]+Period()*60-CurTime();
      i=m/60.0;
      s=m%60;
      m=(m-m%60)/60;
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, m + " minutes " + s + " seconds left to bar end", NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Lot size: ", Lot, NL);
      if (StopTrading) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Not trading", NL);
      else ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trading is allowed", NL);
      if (TradeLong) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trading long", NL);
      else ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Not trading long", NL);
      if (TradeShort) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trading short", NL);
      else ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Not trading short", NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Magic number: ", MagicNumber, NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trade comment: ", TradeComment, NL);
      if (CriminalIsECN) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "CriminalIsECN = true", NL);
      else ScreenMessage = StringConcatenate(ScreenMessage,Gap, "CriminalIsECN = false", NL);
      if (AlertNotTrade) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "AlertNotTrade = true", NL);
      else ScreenMessage = StringConcatenate(ScreenMessage,Gap, "AlertNotTrade = false", NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "MinPipsBetweenTrades: ", MinPipsBetweenTrades, NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "SlPipsFromBreech: ", SlPipsFromBreech, NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "BreechPivotBreaksToTrade: ", BreechPivotBreaksToTrade, NL, NL);      
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trading hours: ", NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Start_hourm:  ", DoubleToStr(start_hourm, 2), NL );
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "End_hourm:  ", DoubleToStr(end_hourm, 2), NL );
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Start_houre:  ", DoubleToStr(start_houre, 2), NL );
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "End_houre:   ", DoubleToStr(end_houre, 2), NL, NL );
      if (AllowHalfClose)
      {
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Half-close enabled ", NL);
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "          PercentToClose: ", PercentToClose, ": BEP: ", BEP, NL );      
      }//if (AllowHalfClose)
      else ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Half-close is disabled ", NL);
      if (StopTradingOnceTargetReached) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "StopTradingOnce%Reached is enabled", NL); 
      if (StopTradingOnceTargetReached)ScreenMessage = StringConcatenate(ScreenMessage,Gap,"When trades reach ", TargetPercentageOfBalance, "% of account balance", NL, NL);
      else ScreenMessage = StringConcatenate(ScreenMessage,Gap, "StopTradingOnce%Reached is disabled", NL, NL);
      if (UseRsiTrendFilter)
      {   
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "UseRsiTrendFilter is enabled: ", NL);
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "RsiPeriod: ", RsiPeriod, NL);
         ScreenMessage = StringConcatenate(ScreenMessage,Gap,"RsiTimeFrame: ", RsiTimeFrame, NL);
         ScreenMessage = StringConcatenate(ScreenMessage,Gap,"RsiMaxContraMoveAllowed: ", RsiMaxContraMoveAllowed, NL, NL );
      }
      else ScreenMessage = StringConcatenate(ScreenMessage,Gap, "UseRsiTrendFilter is disabled: ", NL);
      if (SetTrendManually) 
      {
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "You are setting the Htf manually", NL);
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Your chosen trend is " );
         if (TrendIsUp) ScreenMessage = StringConcatenate(ScreenMessage, up, NL);
         if (TrendIsDown) ScreenMessage = StringConcatenate(ScreenMessage, down, NL);
         if (TrendIsRanging) ScreenMessage = StringConcatenate(ScreenMessage, ranging, NL);         
      }
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Criminal's minimum lot size: ", MarketInfo(Symbol(), MODE_MINLOT), NL, NL );
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Minimum Intraday fib size", NL); 
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "for trade generation: ", MinIntradayFibSize, " pips", NL);
      //Is fib is big enough for trading
      double FibSize = IntradayFibHigh - IntradayFibLow;      
      if (FibSize < MinIntradayFibSize * Point) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Intraday fib size = ", DoubleToStr(FibSize, Digits), ": Not tradable ", NL, NL );
      if (FibSize >= MinIntradayFibSize * Point) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Intraday fib size = ", DoubleToStr(FibSize, Digits), ": Tradable ", NL, NL );
      
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Intraday direction: ", Trend, NL);
      if(UseRsiTrendFilter)ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Htf Rsi trend: ", HtfTrend, NL);
      
      
      Comment(ScreenMessage);

}//void DisplayUserFeedback()



//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
   FiboObjectDelete(monthly); 	// KH Mod
   FiboObjectDelete(weekly); 		// KH Mod
   FiboObjectDelete(daily); 		// KH Mod
   FiboObjectDelete(intraday); 	// KH Mod
   FiboObjectDelete(breech); 		// KH Mod
   //ObjectsDeleteAll(); 				// KH Mod
   
//----
   return(0);
}
/*  
void DrawFib(string Name, color col)
{

//From Luke
//ObjectCreate(objname,OBJ_FIBO,0,tBoxStart,vBuyStop,tBoxStart+FibLength*60*10,vSellStop);         
      
      double HighPrice, LowPrice;
      datetime OpenTime, CloseTime;
      string tf;
      
      if (Name == monthly)
      {
         HighPrice = iHigh(NULL, 43200, 1);
         OpenTime = iTime(NULL, 43200, 1);
         LowPrice = iLow(NULL, 43200, 1);
         CloseTime = iTime(NULL, 43200, 1);
         
      }//if (Name = monthly)
      
            
      if (Name == weekly)
      {
         HighPrice = iHigh(NULL, 10080, 1);
         OpenTime = iTime(NULL, 10080, 1);
         LowPrice = iLow(NULL, 10080, 1);
         CloseTime = iTime(NULL, 10080, 1);
         
      }//if (Name = weekly)
      
      if (Name == daily)
      {
         HighPrice = iHigh(NULL, 1440, 1);
         OpenTime = iTime(NULL, 1440, 1);
         LowPrice = iLow(NULL, 1440, 1);
         CloseTime = iTime(NULL, 1440, 1);
                  
      }//if (Name = daily)
      
      
      //Draw new intraday at the start of trading
      int of = ObjectFind(intraday);
      if (Name == intraday && of == -1)
      {
         HighPrice = iHigh(NULL, 1440, 0);
         OpenTime = iTime(NULL, 1440, 0);
         LowPrice = iLow(NULL, 1440, 0);
         CloseTime = iTime(NULL, 1440, 0);         
         IntradayFibHigh = HighPrice;
         IntradayFibLow = LowPrice;
         GlobalVariableSet(IntradayHighGv, HighPrice);
         GlobalVariableSet(IntradayLowGv, LowPrice); 
      }//if (Name == intraday)
      
      //Draw new intraday a after a new hi/lo/retrace
      if (Name == intraday && of != -1)
      {
         HighPrice = GlobalVariableGet(IntradayHighGv);
         if (HighPrice == 0) HighPrice = IntradayFibHigh;
         OpenTime = iTime(NULL, 1440, 0);
         LowPrice = GlobalVariableGet(IntradayLowGv);
         if (LowPrice == 0) LowPrice = IntradayFibLow;
         CloseTime = iTime(NULL, 1440, 0);
         GlobalVariableSet(IntradayHighGv, HighPrice);
         GlobalVariableSet(IntradayLowGv, LowPrice); 
      }//if (Name == intraday)
      
      //50% breech fib
      if (Name == breech)
      {
         HighPrice = BreechFibHigh;
         LowPrice = BreechFibLow;
         OpenTime = iTime(NULL, 1440, 0);
         CloseTime = iTime(NULL, 1440, 0);
      }//if (Name == breech)
      
      
            
      ObjectCreate(Name,OBJ_FIBO,0,OpenTime,HighPrice,CloseTime,LowPrice);
      ObjectSet(Name, OBJPROP_STYLE, STYLE_DASH);
      ObjectSet(Name, OBJPROP_COLOR, col);
      ObjectSet(Name, OBJPROP_LEVELCOLOR, col);
      ObjectSet(Name, OBJPROP_WIDTH, 1);
      ObjectSet(Name, OBJPROP_FIBOLEVELS, 11);
      ObjectSet(Name, OBJPROP_FIRSTLEVEL+0, 0);
      ObjectSet(Name, OBJPROP_FIRSTLEVEL+1, 100);
      
      if (Name != breech) ObjectSet(Name, OBJPROP_FIRSTLEVEL+0, -0.55);
      if (Name != breech) ObjectSet(Name, OBJPROP_FIRSTLEVEL+1, -0.34);
      ObjectSet(Name, OBJPROP_FIRSTLEVEL+2, 0);
      if (Name != breech) ObjectSet(Name, OBJPROP_FIRSTLEVEL+3, 0.191);
      if (Name != breech) ObjectSet(Name, OBJPROP_FIRSTLEVEL+4, 0.382);
      ObjectSet(Name, OBJPROP_FIRSTLEVEL+5, 0.50);
      if (Name != breech) ObjectSet(Name, OBJPROP_FIRSTLEVEL+6, 0.618);
      if (Name != breech) ObjectSet(Name, OBJPROP_FIRSTLEVEL+7, 0.809);
      ObjectSet(Name, OBJPROP_FIRSTLEVEL+8, 1);
      if (Name != breech) ObjectSet(Name, OBJPROP_FIRSTLEVEL+9, 1.34);
      if (Name != breech) ObjectSet(Name, OBJPROP_FIRSTLEVEL+10, 1.55);
      
      if (Name != breech) ObjectSetFiboDescription(Name, 0, Name + " T2 (-55)"+ "  %$");
      if (Name != breech) ObjectSetFiboDescription(Name, 1, Name + " T1 (-34)"+ "  %$");
      ObjectSetFiboDescription(Name, 2, Name + " Low (0)"+ "  %$");
      if (Name != breech) ObjectSetFiboDescription(Name, 3, Name + " S1 (19.1)"+ "  %$");
      if (Name != breech) ObjectSetFiboDescription(Name, 4, Name + " Sell (38.2)"+ "  %$");
      ObjectSetFiboDescription(Name, 5, Name + " Pivot (50)"+ "  %$");
      if (Name != breech) ObjectSetFiboDescription(Name, 6, Name + " Buy (61.8)"+ "  %$");
      if (Name != breech) ObjectSetFiboDescription(Name, 7, Name + " R1 (80.9)"+ "  %$");
      ObjectSetFiboDescription(Name, 8, Name + " High (100)"+ "  %$");
      if (Name != breech) ObjectSetFiboDescription(Name, 9, Name + " T1 (134)"+ "  %$");
      if (Name != breech) ObjectSetFiboDescription(Name, 10, Name + " T2 (155)"+ "  %$");
      

}//void DrawFib(string Name, color col)
*/

void HalfCloseAndMoveToBreakeven()
{
   
   double LotsToClose = Lot * (PercentToClose / 100);
   double MinStopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL) * Point;
            
   for (int cc = 0; cc <= ArraySize(TicketNumbers); cc++)
   {
      int t = TicketNumbers[cc];
      if (!OrderSelect(t, SELECT_BY_TICKET) ) continue;
      //Half close
      if (OrderType() == OP_BUY && Ask >= IntradayFibHigh && OrderProfit() > 0 && OrderLots() == Lot)
      {
         //Close half the trade, call GetPosition to reset the ticket numbers, and reset cc to force a rerun round the loop
         bool result = OrderClose(t, LotsToClose, OrderClosePrice(), 200, CLR_NONE);
         if (!result)
	      {
	          int err=GetLastError();
             Print(t, " half-close failed with error(",err,"): ",ErrorDescription(err));               
	      }//if (!result)			  
         if (result) 
         {
            GetPosition();
            cc = -1;
            Sleep(500);
         }//if (result) 
      }//if (OrderType() == OP_BUY && Ask >= IntradayFibHigh)
      
      //Move tp to be
      if (OrderType() == OP_BUY && OrderLots() < Lot && OrderStopLoss() < OrderOpenPrice() && cc > -1)
      {
         double NewStop = NormalizeDouble(OrderOpenPrice() + (BEP * Point), Digits);
         if (Ask - NewStop < MinStopLevel) continue;
         result = OrderModify(t, OrderOpenPrice(), NewStop, OrderTakeProfit(), 0, CLR_NONE);
	      if (!result)
	      {
	           err=GetLastError();
              Print(t, " SL  move to breakeven failed with error(",err,"): ",ErrorDescription(err));               
	      }//if (!result)
	      if (result) 
         {
            Print(t, " SL  move to breakeven");
         }//if (result) 
      }//if (OrderType() == OP_BUY && OrderLots() < Lot && OrderTakeProfit() < OrderOpenPrice() && cc > -1)
      
      //Half close
      if (OrderType() == OP_SELL && Bid <= IntradayFibLow && OrderProfit() > 0 && OrderLots() == Lot)
      {
         //Close half the trade, call GetPosition to reset the ticket numbers, and reset cc to force a rerun round the loop
         result = OrderClose(t, LotsToClose, OrderClosePrice(), 200, CLR_NONE);
         if (!result)
	      {
	          err=GetLastError();
             Print(t, " half-close failed with error(",err,"): ",ErrorDescription(err));               
	      }//if (!result)			  
         if (result) 
         {
            GetPosition();
            cc = -1;
            Sleep(500);
         }//if (result) 
      }//if (OrderType() == OP_SELL && Bid <= IntradayFibLow)
      
      //Move tp to be
      if (OrderType() == OP_SELL && OrderLots() < Lot && OrderStopLoss() > OrderOpenPrice() && cc > -1)
      {
         NewStop = NormalizeDouble(OrderOpenPrice() - (BEP * Point), Digits);
         if (NewStop - Bid < MinStopLevel) continue;
         result = OrderModify(t, OrderOpenPrice(), NewStop, OrderTakeProfit(), 0, CLR_NONE);
	      if (!result)
	      {
	           err=GetLastError();
              Print(t, " SL  move to breakeven failed with error(",err,"): ",ErrorDescription(err));
	      }//if (!result)
	      if (result) 
         {
            Print(t, " SL  move to breakeven");
         }//if (result) 
      }//if (OrderType() == OP_BUY && OrderLots() < Lot && OrderTakeProfit() < OrderOpenPrice() && cc > -1)
      
   }//for (int cc = 0; cc <= ArraySize(TicketNumbers); cc++)
   
   
}//End void HalfCloseAndMoveToBreakeven()


double GetPreviousHigh(double CurrentHigh, int& CurrentHighTime) 
{
    //Finds a new previous high
    //If none exists on the current tf, then pull out to higher tf's
         
    //Set up tf's
    int tf[7];
    tf[0] = Period();
    tf[1] = PERIOD_M30;
    tf[2] = PERIOD_H1;
    tf[3] = PERIOD_H4;
    tf[4] = PERIOD_D1;
    tf[5] = PERIOD_W1;
    tf[6] = PERIOD_MN1;
    
    int tfc;//Time frame counter
    
    for (tfc = 0; tfc <= 6; tfc++)
    {
      for (int cc = 0; cc <= iBars(NULL, tf[tfc]); cc++)
      {
         double zz = iFractals(NULL, tf[tfc], MODE_UPPER, cc);
         if(zz > 0 && zz > CurrentHigh)
         {
				CurrentHighTime = iTime(NULL,tf[tfc],cc); 
            return(zz);
         }//if(z1>0)      
      }//for (int cc = 0; cc <= iBars(NULL, tf[tfc]); cc++)
      
    }//for (tfc = 0; tfc <= 6; tfc++)


}//End double GetPreviousHigh(double CurrentHigh, int& CurrentHighTime) 

double GetPreviousLow(double CurrentLow, int& CurrentLowTime) 
{
   //Finds a new previous low.
   //If none exists on the current tf, then pull out to higher tf's
         
    //Set up tf's
    int tf[7];
    tf[0] = Period();
    tf[1] = PERIOD_M30;
    tf[2] = PERIOD_H1;
    tf[3] = PERIOD_H4;
    tf[4] = PERIOD_D1;
    tf[5] = PERIOD_W1;
    tf[6] = PERIOD_MN1;
    
    int tfc;//Time frame counter
    
    for (tfc = 0; tfc <= 6; tfc++)
    {
      for (int cc = 0; cc <= iBars(NULL, tf[tfc]); cc++)
      {
         double zz = iFractals(NULL, tf[tfc], MODE_LOWER, cc);
         if(zz > 0 && zz < CurrentLow)
         {
				CurrentLowTime = iTime(NULL,tf[tfc],cc); 
            return(zz);
         }//if(z1>0)      
      }//for (int cc = 0; cc <= iBars(NULL, tf[tfc]); cc++)
      
    }//for (tfc = 0; tfc <= 6; tfc++)
      
}//End double GetPreviousLow(double CurrentLow, int& CurrentLowTime) 

bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
{
   
   if (StopTrading) return(true);
   
   if (!IsTradeAllowed() ) return(false);
   
   int slippage = 10;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   color col = Red;
   if (type == OP_BUY) col = Green;
   
   if (!CriminalIsECN) int ticket = OrderSend(Symbol(),type, lotsize, price, slippage, stop, take, comment, MagicNumber, 0, col);
   
   
   //Is a 2 stage criminal
   if (CriminalIsECN)
   {
      ticket = OrderSend(Symbol(),type, lotsize, price, slippage, 0, 0, comment, MagicNumber, 0, col);
	   if (stop != 0)
	   {
		   if (ticket > 0)
		   bool result = OrderModify(ticket, OrderOpenPrice(), stop, take, 0, CLR_NONE);
		   if (!result)
		   {
		       int err=GetLastError();
             Print(Symbol(), " ", type," SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
		   }//if (!result)			  
	   }//if (Sl != 0)
      
      
   }//if (CriminalIsECN)
   
   //Error trapping for both
   if (ticket < 0)
   {
      string stype;
      if (type == OP_BUY) stype = "OP_BUY";
      if (type == OP_SELL) stype = "OP_SELL";
      err=GetLastError();
      //Alert(Symbol(), " ", stype," Simone fib order send failed with error(",err,"): ",ErrorDescription(err));
      Print(Symbol(), " ", stype," Simone fib order send failed with error(",err,"): ",ErrorDescription(err));
      return(false);
   }//if (ticket < 0)  
   
   //Got this far, so trade send succeeded
   return(true);
   
}//End bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)

void GetPosition()
{
   NoOfTrades = 0;
   TicketNo = 0;
   if (OrdersTotal() == 0) return;
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0)
      {
         NoOfTrades++;
         if (NoOfTrades == 1) TicketNo = OrderTicket();//Tells the robot which is the most recent trade in a sequence
      }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0)
      
   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)

   int iNew3 = ArrayResize(TicketNumbers, NoOfTrades + 1);//Higher time frame bars
   
   if (NoOfTrades < 2) 
   {
      TicketNumbers[0] = TicketNo;//Will be a zero value if there are no trades open
      return;
   }//if (NoOfTrades < 2) 
   
   //Save ticket numbers in an array for use in breakeven/js functions
   int t;
   for (cc = 0; cc <= OrdersTotal() ; cc++)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0)
      {
         TicketNumbers[t] = OrderTicket();
         t++;
      }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0)
      
   }//for (int cc = 0; cc <= OrdersTotal() ; cc==)
   
   TicketNo = TicketNumbers[t-1];//Latest trade in the sequence

}//End void GetPosition()

bool UpdateStopLosses()
{
   //Moves stop losses every time an additional new trade opens.
   //Only called when there is >1 trade open
   
   bool failed = false;
   string direction;
   
   //Get trade direction
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0)
      {
         if (OrderType() == OP_BUY) direction = long;
         if (OrderType() == OP_SELL) direction = short;
         break;
      }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0)      
   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   
   
   //Get the open price for Order(NoOfTrades - 1)
   int t = NoOfTrades;
   for (cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0)
      {
         t--;
         if (t == NoOfTrades - 2) break;
      }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0)      
   }//for (cc = OrdersTotal() - 1; cc >= 0 ; cc--)
      
   if (t == -1) return;//Nothing else to do
   
   double TradePrice = OrderOpenPrice();

   
   //Calculate the breakeven stop loss for trades NoOfTrades - n
   if (direction == long) double NewStop = NormalizeDouble(TradePrice + BEP * Point, Digits);
   if (direction == short) NewStop = NormalizeDouble(TradePrice - BEP * Point, Digits);
   
   //Make the required modifications
   t = NoOfTrades;
   for (cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0)
      {
         if (t < NoOfTrades) 
         {
            bool ModifyNeeded = false;
            if (OrderType() == OP_BUY && OrderStopLoss() < NewStop) ModifyNeeded = true;
            if (OrderType() == OP_SELL && OrderStopLoss() > NewStop) ModifyNeeded = true;
            
            if (ModifyNeeded) bool result=OrderModify(OrderTicket(), OrderOpenPrice(), NewStop, OrderTakeProfit(), 0, CLR_NONE);
            if (!result)
            {
               //int err=GetLastError();
               //Alert(Symbol(), " Fib OrderModify Error: Type=", OrderType(),DoubleToStr(NewStop,Digits), ErrorDescription(err));
               //Print(Symbol(), " Fib OrderModify Error: Type=", OrderType()," ticket=",OrderTicket()," Open=",OrderOpenPrice()," Current stop=",DoubleToStr(OrderStopLoss(),Digits)," SL_New=",DoubleToStr(NewStop,Digits)," take=",OrderTakeProfit()," Error(",err,"): ",ErrorDescription(err));              
               failed = true;
            }//if (!result)
            
         }//if (t < NoOfTrades - 1) 
         t--;
         if (result) Sleep(500);
      }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0)      
   }//for (cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   
   
   return(failed);
   

}//bool UpdateStopLosses()

void CalculateAndDrawBreech(bool BreechMustLeadMarket)
{
   
   //Pick up after a reinitialise
   double FracHigh, FracLow;
   int    FracHighTime, FracLowTime; 
   
   FracHigh = GlobalVariableGet(BreechHighGv);
   FracLow = GlobalVariableGet(BreechLowGv);
   FracHighTime = GlobalVariableGet(BreechHighTimeGv); 
   FracLowTime = GlobalVariableGet(BreechLowTimeGv); 
   //No need to find new fractals if this is a pick up after re-initialising, so long as there is no open trade
   if (FracHigh > 0 && FracLow > 0 && TicketNo == 0)
   {
      BreechFibHigh = FracHigh;
      BreechFibLow  = FracLow;
      BreechFibHighTime = FracHighTime; 
      BreechFibLowTime = FracLowTime; 
      DrawFib(breech, BreechFibColour);
      return;
   }//if (FracHigh > 0 && FracLow > 0)
   
   //Find the previous fractal
   for (int cc = 1; cc < Bars; cc++)
   {
      if (FracHigh == 0) { FracHigh = iFractals(NULL, 0, MODE_UPPER,cc); FracHighTime = Time[cc]; } 
      if (FracLow == 0)  { FracLow  = iFractals(NULL, 0, MODE_LOWER,cc); FracLowTime  = Time[cc]; } 
      if (FracHigh > 0 && FracLow > 0) break;
   }//for (int cc = 1; cc > Bars; cc--)

   BreechFibHigh = FracHigh;
   BreechFibLow  = FracLow;
   BreechFibHighTime = FracHighTime; 
   BreechFibLowTime  = FracLowTime; 
   double FibSize = BreechFibHigh - BreechFibLow;      
   BreechPivot = NormalizeDouble(BreechFibLow + (FibSize / 2), Digits); 
         
   //Make sure the breech fib is moved after a trade opens.
   //TicketNo is set to the most recent open trade in a sequence, eg no 3 of 3, 2 of 2 etc
   double MinPivot = BreechPivot;
      
   if (TicketNo > 0)
   {
      if (OrderSelect(TicketNo, SELECT_BY_TICKET))
      {
         if (OrderCloseTime() == 0) MinPivot = OrderOpenPrice(); 
         if (OrderCloseTime() > 0) TicketNo = 0;
      }//if (OrderSelect(TicketNo))
      
   }//if (TicketNo > 0)
      //Alert(Symbol(), "  ", TicketNo);

   //The 50% must lead the market if the breech is being re-drawn following a successful trade-send/alert
   if (BreechMustLeadMarket)
   {   
      if (Trend == down)
      {
         //Ensure the new BreechPivot is lower than Bid
         MinPivot = NormalizeDouble(MinPivot - (MinPivotDifferenceAfterUpdate * Point), Digits);
         while (true)
         {
            FibSize = BreechFibHigh - BreechFibLow;      
            BreechPivot = NormalizeDouble(BreechFibLow + (FibSize / 2), Digits); 
            if (TicketNo == 0 && Bid > BreechPivot && BreechPivot <= MinPivot) break;
            if (TicketNo > 0 && BreechPivot <= MinPivot) break;
            BreechFibLow  = GetPreviousLow(BreechFibLow, BreechFibLowTime); //KH MOD
         }//while (true)
   
      }//if (Trend == down)

      if (Trend == up)
      {
         //Ensure the new BreechPivot is > Ask         
         MinPivot = NormalizeDouble(MinPivot + (MinPivotDifferenceAfterUpdate * Point), Digits);
         while (true)
         {
            FibSize = BreechFibHigh - BreechFibLow;      
            BreechPivot = NormalizeDouble(BreechFibLow + (FibSize / 2), Digits); 
            if (TicketNo == 0 && Ask < BreechPivot && BreechPivot >= MinPivot) break;
            if (TicketNo > 0 && BreechPivot >= MinPivot) break;
            BreechFibHigh  = GetPreviousHigh(BreechFibHigh, BreechFibHighTime); 
         }//while (true)
      }//if (Trend == up)
   }//if (BreechMustLeadMarket)
   


   DrawFib(breech, BreechFibColour);
   
}//End void CalculateAndDrawBreech()

bool IsTargetReached()
{
   
   if (OrdersHistoryTotal() == 0) return(false);
   
   int iHandle;
   int iHistoryTotal = OrdersHistoryTotal();
   double dHistoryProfit=0;
   
   // Calculate history total
   if (iHistoryTotal>0)
   {
      for(int k=0;k<iHistoryTotal;k++)
      {
         OrderSelect(k,SELECT_BY_POS,MODE_HISTORY);
         int DayLocal = TimeDay(TimeCurrent() );
         int TradeDay = TimeDay(OrderCloseTime() );
         if (TradeDay == DayLocal)
         {
            dHistoryProfit += OrderProfit();
            dHistoryProfit += OrderSwap();
         }//if (TradeDay == TradeDay)
         
      }//for(int k=0;k<iHistoryTotal;k++)
      
   }//if (iHistoryTotal>0)

   
   double TargetProfit = (AccountBalance() * TargetPercentageOfBalance / 100 );
   if (dHistoryProfit >= TargetProfit) return(true);
   
   return(false);

}//End bool IsTargetReached()

void AdjustTakeProfit()
{
   //Adjusts tp of open trades when the Intraday has been adjusted to accommodate a new valid swing.
   //Only called when there are open trades.
   
   
   double FibSize = IntradayFibHigh - IntradayFibLow;
   double IntradayLongT1 = NormalizeDouble(IntradayFibLow + (FibSize * 134 / 100) - (TakeProfitsPipTolerance * Point), Digits);
   double IntradayShortT1 = NormalizeDouble(IntradayFibLow - (FibSize * 34 / 100) +  (TakeProfitsPipTolerance * Point), Digits);
   
   for (int cc = 0; cc <= ArraySize(TicketNumbers); cc++)
   {      
      int t = TicketNumbers[cc];
      if (!OrderSelect(t, SELECT_BY_TICKET) ) continue;
      
      if (OrderType() == OP_BUY)
      {
         if (OrderTakeProfit() < IntradayLongT1)
         {
            bool result = OrderModify(t, OrderOpenPrice(), OrderStopLoss(), IntradayLongT1, 0, CLR_NONE);
         }//if (OrderTakeProfit() < IntradayLongT1)         
      }//if (OrderType() == OP_BUY)
      
      if (OrderType() == OP_SELL)
      {
         if (OrderTakeProfit() > IntradayShortT1)
         {
            result = OrderModify(t, OrderOpenPrice(), OrderStopLoss(), IntradayShortT1, 0, CLR_NONE);
         }//if (OrderTakeProfit() < IntradayLongT1)         
      }//if (OrderType() == OP_SELL
         
   }//for (int cc = 0; cc <= ArraySize(TicketNumbers); cc++)

}//void AdjustTakeProfit()

void GetHtfTrend()
{



      double RsiVal = iRSI(NULL, RsiTimeFrame, RsiPeriod, PRICE_CLOSE, 0);
      double PreviousRsiVal = iRSI(NULL, RsiTimeFrame, RsiPeriod, PRICE_CLOSE, 1);
      
      
            
      HtfTrend = undecided;
      if (RsiVal > 55)
      {
         HtfTrend = up;
         if (PreviousRsiVal - RsiVal >= RsiMaxContraMoveAllowed) 
         {
            Trend = upbutuntradable;            
         }//if (PreviousRsiVal - RsiVal >= RsiMaxContraMoveAllowed) 
         
      }//if (RsiVal > 55)
      
      if (RsiVal < 45)
      {
         HtfTrend = down;
         if (RsiVal - PreviousRsiVal >= RsiMaxContraMoveAllowed) 
         {
            Trend = downbutuntradable;            
         }//if (PreviousRsiVal - RsiVal >= RsiMaxContraMoveAllowed) 
      }//if (RsiVal < 45)
      
      

}//End void GetHtfTrend()

////////////////////////////////////
// KH Fibo Generation Mods Start ///
////////////////////////////////////
#define CHARTWDW						0
#define MAXFIBOLEVELS				11
#define FIBTXTSZE						7  // Use this define if Long Name (Name) used for Fib Line Desc
//#define FIBTXTSZE						8  // Use this define if Short Name (SName) used for Fib Line Desc
#define FIB_OPN_TIME					0
#define FIB_CLS_TIME					1
#define FIB_HI_PRICE					2
#define FIB_LO_PRICE					3
  
void DrawFib(string Name, color FibLineClr)
{
   double HighPrice, LowPrice, FiboLev[MAXFIBOLEVELS], FiboInfo[MAXFIBOLEVELS];
   int    HighPriceTime, LowPriceTime;
   string FiboDesc[MAXFIBOLEVELS], SName, FiboDir;
   datetime OpenTime, CloseTime;
   static datetime SaveDailyCloseTime = EMPTY_VALUE;
   color FiboTextClr;
   
   if (Name == monthly)
   {
		FiboObjectDelete( Name );		
      GenFiboObjSetVars( Name, HighPrice, LowPrice, OpenTime, CloseTime, FiboDir);
      SName = "MNLY"; 
   }//if (Name = monthly)
           
   else if (Name == weekly)
   {
		FiboObjectDelete( Name );		
      GenFiboObjSetVars( Name, HighPrice, LowPrice, OpenTime, CloseTime, FiboDir); 
      SName = "WKLY"; 
   }//if (Name = weekly)
   
   else if (Name == daily)
   {
		FiboObjectDelete( Name );		
      GenFiboObjSetVars( Name, HighPrice, LowPrice, OpenTime, CloseTime, FiboDir);
      SaveDailyCloseTime = CloseTime; 
      SName = "DYLY"; 
   }//if (Name = daily)
   
   //Draw new intraday at the start of trading
   else if (Name == intraday && FiboObjectFind(intraday) == -1)
   {
		FiboObjectDelete( Name );		
		//IntradayFibHigh = GetPreviousHigh( High[0], IntradayFibHighTime );
		HighPrice = iHigh(NULL, 1440, 0);
		IntradayFibHigh = HighPrice;
		//IntradayFibLow  = GetPreviousLow ( Low[0],  IntradayFibLowTime );
		LowPrice = iLow(NULL, 1440, 0);
		IntradayFibLow  = LowPrice;
		OpenTime = Time[2*BarsPerFibDisplay];
      if( IntradayFibHighTime > IntradayFibLowTime ) {FiboDir = " SwUp"; } else { FiboDir = " SwDn"; }
      CloseTime = Time[BarsPerFibDisplay]; 
      SaveGlobalVars( intraday );
      SName = "INDY"; 
   }//if (Name == intraday && FiboObjectFind(intraday) == -1)
   
   //Draw new intraday after a new hi/lo/retrace
   else if (Name == intraday && FiboObjectFind(intraday) != -1)
   {
		FiboObjectDelete( Name );		
      HighPrice = GlobalVariableGet(IntradayHighGv); if(HighPrice == 0) HighPrice = IntradayFibHigh;
      LowPrice  = GlobalVariableGet(IntradayLowGv);  if(LowPrice == 0)  LowPrice  = IntradayFibLow;
      IntradayFibHigh = HighPrice; IntradayFibLow = LowPrice;
      
      HighPriceTime = GlobalVariableGet(IntradayHighTimeGv); if(HighPriceTime == 0) HighPriceTime = IntradayFibHighTime;
      LowPriceTime  = GlobalVariableGet(IntradayLowTimeGv);  if(LowPriceTime == 0)  LowPriceTime  = IntradayFibLowTime;
      IntradayFibHighTime = HighPriceTime; IntradayFibLowTime = LowPriceTime;
		OpenTime = Time[2*BarsPerFibDisplay];

      if( IntradayFibHighTime > IntradayFibLowTime ) {FiboDir = "-SwUp"; } else { FiboDir = "-SwDn"; }
      CloseTime = Time[BarsPerFibDisplay]; 
      SaveGlobalVars( intraday );
      SName = "INDY"; 
   }//if (Name == intraday && FiboObjectFind(intraday) != -1)
   
   //50% breech fib
   else if (Name == breech)
   {
		FiboObjectDelete( Name );		
      HighPrice = BreechFibHigh;
      LowPrice = BreechFibLow;
      HighPriceTime = BreechFibHighTime;
      LowPriceTime = BreechFibLowTime;
      OpenTime  = Time[BarsPerFibDisplay];
      CloseTime = Time[0];

      if( BreechFibHighTime > BreechFibLowTime ) { FiboDir  = "-SwUp"; } else { FiboDir = "-SwDn";   } 
      SaveGlobalVars( breech );
      SName = "BRCH"; 
   }//if (Name == breech)
   
   FiboInfo[FIB_OPN_TIME] = OpenTime;
   FiboInfo[FIB_CLS_TIME] = CloseTime;
   FiboInfo[FIB_HI_PRICE] = HighPrice;
   FiboInfo[FIB_LO_PRICE] = LowPrice;
   
   for( int ii = 0; ii < MAXFIBOLEVELS; ii++ )
   {
		if( (Name != breech) || ii == 2 || ii == 5 || ii == 8 ) 
		{ 
			FiboLev[ii]  = StaticFibLevels[ii]; 
			FiboDesc[ii] = Name+" "+StaticFibDesc[ii]; // Use this code if Long Name (Name) used for Fib Line Desc & TxtSize #define = 7
//			FiboDesc[ii] = Name+" "+StaticFibDesc[ii]; // Use this code if Short Name (SName) used for Fib Line Desc & TxtSize #define = 8
		}
		else FiboLev[ii] = EMPTY_VALUE;
	}//End for( ii = 0; ii < MAXFIBOLEVELS; ii++ )    
   CreateFiboObjSet( Name, FiboInfo, FiboLev, FiboDesc, FiboDir, FibLineClr );
	WindowRedraw();
}//void DrawFib(string Name, color col)
void CreateFiboObjSet( string name, double FiboInfo[], double FiboLev[], string FiboDesc[], string dir, color lclr )
{
	string FibLineDesc;	
	int    OpnTime = FiboInfo[FIB_OPN_TIME], ClsTime = FiboInfo[FIB_CLS_TIME],  MidTime = (FiboInfo[FIB_CLS_TIME]+FiboInfo[FIB_OPN_TIME])*0.5;
	double FiboRange = FiboInfo[FIB_HI_PRICE] - FiboInfo[FIB_LO_PRICE], Price, LstFibLev;
	
	for( int ii = 0; ii < MAXFIBOLEVELS; ii++ )
	{
		if( FiboLev[ii] != EMPTY_VALUE ) 
		{
			LstFibLev = FiboLev[ii];
			Price = FiboInfo[FIB_LO_PRICE] + FiboLev[ii] * FiboRange;
			FibLineDesc = FiboDesc[ii] + DoubleToStr(Price,4);
			DrawFiboLine(name, ii, OpnTime, ClsTime, Price, lclr, 0);
			DrawFiboDesc(name, ii, FibLineDesc, MidTime, Price, lclr, FIBTXTSZE );
		}//End if( FiboLev[ii] != EMPTY_VALUE )
	}//End if( FiboLev[ii] != EMPTY_VALUE ) 
	Price = FiboInfo[FIB_LO_PRICE] + (LstFibLev + 0.3) * FiboRange;
	DrawFiboDesc(name, ii, (name+dir), MidTime, Price, lclr, FIBTXTSZE+2 );   
}//End void CreateFiboObjSet( string name, string fibsname, double FiboInfo[], double FiboLev[], string FiboDesc[], color tclr, color lclr ) 
   
void DrawFiboLine(string objname, int whichone, datetime x1, datetime x2, double price, color clr, int width)
{
	string name = objname+"_Lev"+whichone;	
	ObjectCreate(name, OBJ_TREND, CHARTWDW, x1, price, x2, price);
	ObjectSet(name, OBJPROP_RAY, 0);
	ObjectSet(name, OBJPROP_COLOR, clr);
	ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
	ObjectSet(name, OBJPROP_WIDTH, width );
}//End void DrawFiboLine(string objname, int whichone, datetime x1, datetime x2, double price, color clr, int width)

void DrawFiboDesc(string objname, int whichone, string text, datetime x1, double y1, color clr, int txtsze ) 
{ 
	string name = objname+"_DESC"+whichone;	
	ObjectCreate(name, OBJ_TEXT, CHARTWDW, x1, y1-Point*1);
	ObjectSetText(name, text, txtsze,"Lucida Console", clr);
}//End void DrawFiboDesc(string objname, int whichone, string text, datetime x1, double y1, color clr, int txtsze ) 
void GenFiboObjSetVars( string type, double& HiPrice, double& LoPrice, int& OpnTime, int& ClsTime, string& dir )
{
	int tf, HighPriceTime, LowPriceTime, WhichFib; 
	
	if( type == monthly ) 		{ tf = PERIOD_MN1; WhichFib = 3; }
	else if( type == weekly )  { tf = PERIOD_W1;  WhichFib = 2; }
	else if( type == daily )   { tf = PERIOD_D1;  WhichFib = 1; }
   HiPrice = iHigh(NULL, tf, 1);
   LoPrice = iLow (NULL, tf, 1);
   if( iClose(NULL, tf, 1) < iOpen(NULL, tf, 1) ) { dir = "-SwDn"; }  else { dir = "-SwUp"; }
   OpnTime = Time[BarsPerFibDisplay*2 + WhichFib*BarsPerFibDisplay];
   ClsTime = Time[BarsPerFibDisplay*2 + (WhichFib-1)*BarsPerFibDisplay];
   return(0);
}// End void GenFiboObjSetVars( string type, double& HiPrice, double& LoPrice, int& OpnTime, int& ClsTime, color& TxtClr )

//////////////////////////////////
// KH Fibo Generation Mods End ///
// KH Aux Functions Start      ///
//////////////////////////////////
//+-------------------------------------------------------------------------+//
void SaveGlobalVars( string type ) 
{
	if( type == intraday )
	{
      GlobalVariableSet(IntradayHighGv, IntradayFibHigh);
      GlobalVariableSet(IntradayLowGv, IntradayFibLow);      
      GlobalVariableSet(IntradayHighTimeGv, IntradayFibHighTime); 
      GlobalVariableSet(IntradayLowTimeGv, IntradayFibLowTime);       
   }//End if( type == intraday )      
	else if( type == breech )
	{
   	GlobalVariableSet(BreechHighGv, BreechFibHigh);
   	GlobalVariableSet(BreechLowGv, BreechFibLow);      
   	GlobalVariableSet(BreechHighTimeGv, BreechFibHighTime); 
   	GlobalVariableSet(BreechLowTimeGv, BreechFibLowTime); 
   }//End if( type == breech )
}//End void SaveGlobalVars( string type )       
//+-------------------------------------------------------------------------+//
void ResetFiboState( string type, bool deletefibo )
{
	if( type == intraday )
	{
		if( deletefibo ) FiboObjectDelete( intraday );
   	GlobalVariableDel(IntradayHighGv);
   	GlobalVariableDel(IntradayLowGv);
   	GlobalVariableDel(IntradayHighTimeGv); 
   	GlobalVariableDel(IntradayLowTimeGv); 
   }// End if( type == intraday )
	else if( type == breech )
	{
		if( deletefibo ) FiboObjectDelete( breech );
  		GlobalVariableDel(BreechHighGv);
   	GlobalVariableDel(BreechLowGv);
   	GlobalVariableDel(BreechHighTimeGv); 
   	GlobalVariableDel(BreechLowTimeGv); 
   }//End if( type == breech )
}//End void ResetFiboState( string type, bool delfibobj ) 
//+-------------------------------------------------------------------------+//
void FiboObjectDelete( string typename ) 
{
	string name;
	for( int ii = 0; ii < MAXFIBOLEVELS+1; ii++ )
	{
		name = typename+"_Lev"+ii;	
		if( ObjectFind( name ) != -1 ) ObjectDelete( name );
		name = typename+"_DESC"+ii;
		if( ObjectFind( name ) != -1 ) ObjectDelete( name );
	}//End for( int ii = 0; ii < ObjectsTotal(); ii++ )
}//End void FiboObjectDelete( string type )
//+-------------------------------------------------------------------------+//
#define FOUND		0
#define NOTFOUND	-1
int FiboObjectFind( string type ) 
{
	for( int ii = 0; ii < ObjectsTotal(); ii++ )
	{
		if( StringFind( ObjectName(ii),type, 0 ) != -1 ) return(FOUND);
	}//End for( int ii = 0; ii < ObjectsTotal(); ii++ )
	return(NOTFOUND);
}//End void FiboObjectDelete( string type )
//+-------------------------------------------------------------------------+//
////////////////////////////
// KH Aux Functions End ////
////////////////////////////

bool GetBreechPivotCandlesClose(string direction, double target)
{
   //Tests for confirmation candles opening in the correct direction for the trade - above 50% for long and below for short

   if (BreechPivotBreaksToTrade == 0) 
   {
      if (direction == up && Low[1] > target) return(false);
      if (direction == down && High[1] < target) return(false);
      return(true);
   }//if (BreechPivotBreaksToTrade == 0) 
   
   
   //Confirmation candles
   for (int cc = 1; cc <= BreechPivotBreaksToTrade; cc++)
   {
      //Check long trade
      if (direction == up)
      {
         if (Close[cc] < target) return(false);
      }//if (direction == up)
   
      //Check short trade
      if (direction == down)
      {
         if (Close[cc] > target) return(false);
      }//if (direction == up)
   
   }//for (int cc = 1; cc <= BreechPivotBreaksToTrade; cc++)
   
   //Confirm that this is a cross, to cater for trade starting above/below the 50% in the correct trade direction
   if (direction == up && Open[BreechPivotBreaksToTrade + 1] > target) return(false);
   if (direction == down && Open[BreechPivotBreaksToTrade + 1] < target) return(false);
   
   //Got this far, so there have been enough breaks of the breech pivot, and it is a cross not a bounce
   return(true);

}//End bool GetBreechPivotCandlesClose(string direction, double target)



//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----

   

   static int LastBarTime = 0;
   loadInitialParams();
   
   if (RobotDisabled )
   {
      Comment("The robot has been suspended. Reason: ", DisabledMessage);
      return;
   }//if (RobotDisabled )
 
   static int OldOrdersTotal;
   
   if (OrdersTotal() != OldOrdersTotal) 
   {
      GetPosition();
      OldOrdersTotal = OrdersTotal();
   }//if (OrdersTotal() != OldOrdersTotal) 
   
   //Half-close and move to be of open trades
   if (NoOfTrades > 0 && AllowHalfClose)
   {
      HalfCloseAndMoveToBreakeven();
   }//if (NoOfTrades > 0 && AllowHalfClose)
   
   
   //Code to take care of a stop loss update failure
   static bool ForceSlManipulation = false;
   if (ForceSlManipulation) ForceSlManipulation = UpdateStopLosses();
   
   
   //Draw new fibs at the start of each D1 candle
   if( Time[0] != LastBarTime ) 
   {
      if (DrawMonthly) DrawFib(monthly, MonthlyFibColour);
      if (DrawWeekly) DrawFib(weekly, WeekFibColour);
      if (DrawDaily) DrawFib(daily, DailyFibColour);
      DrawFib(intraday, IntradayFibColour);
      DrawFib(breech, BreechFibColour);
      LastBarTime = Time[0];
   }// if( DidBarJustClose() )

   
   
   //Trading times
   int hour = TimeHour(TimeLocal() );
   
   if (end_hourm < start_hourm)
	{
		end_hourm += 24;
	}
	

	if (end_houre < start_houre)
	{
		end_houre += 24;
	}
	
	bool ok2Trade = (hour >= start_hourm && hour <= end_hourm) || (hour >= start_houre && hour <= end_houre);

	// adjust for past-end-of-day cases
	// eg in AUS, USDJPY trades 09-17 and 22-06
	// so, the above check failed, check if it is because of this condition
	if (!ok2Trade && hour < 12)
	{
 		hour += 24;
		ok2Trade = (hour >= start_hourm && hour <= end_hourm) || (hour >= start_houre && hour <= end_houre);

		
		// so, if the trading hours are 11pm - 6am and the time is between  midnight to 11am, (say, 5am)
		// the above code will result in comparing 5+24 to see if it is between 23 (11pm) and 30(6+24), which it is...
	}


   // check for end of day by looking at *both* end-hours

   if (hour >= MathMax(end_hourm, end_houre))
   {      
      Comment("Outside trading hours\nstart_hourm-end_hourm: ", start_hourm, "-",end_hourm, "\nstart_houre-end_houre: ", start_houre, "-",end_houre);
      FiboObjectDelete(monthly); // KH MOD
      FiboObjectDelete(weekly); // KH MOD
      FiboObjectDelete(daily); // KH MOD
      FiboObjectDelete(intraday); // KH MOD
      FiboObjectDelete(breech); // KH MOD
      GlobalVariableDel(BreechHighGv);
      GlobalVariableDel(BreechLowGv);
      GlobalVariableDel(IntradayHighGv);
      GlobalVariableDel(IntradayLowGv);
      return;
   }//if (hour >= MathMax(end_hourm, end_houre))
   
   if (!ok2Trade)
   {
      Comment("Outside trading hours\nstart_hourm-end_hourm: ", start_hourm, "-",end_hourm, "\nstart_houre-end_houre: ", start_houre, "-",end_houre);
      GlobalVariableDel(BreechHighGv);
      GlobalVariableDel(BreechLowGv);
      GlobalVariableDel(IntradayHighGv);
      GlobalVariableDel(IntradayLowGv);
      return;
   }//if (hour < start_hourm)
   
   
   //Draw a new intraday fib at the start of trading
   int of = FiboObjectFind(intraday);  
   if (of == -1)
   {      
      if (DrawIntraday) DrawFib(intraday, IntradayFibColour);
   }//if (hour >= start_hourm && hour <= end_houre & of == -1)
   
   
   //Redraw intraday fib on a confirmed new hi/lo, or a cross of T1
   double FibSize = IntradayFibHigh - IntradayFibLow;
   double IntradayR1 = NormalizeDouble(IntradayFibLow + (FibSize * 80.9 / 100), Digits);
   double NewHigh = iHigh(NULL, 1440, 0);
   int	 NewHighTime; 
   if (NewHigh > IntradayFibHigh && Ask <= IntradayR1)
   {
      IntradayFibHigh = GetPreviousHigh(NewHigh, NewHighTime); 
      IntradayFibHighTime = NewHighTime;
      DrawFib(intraday, IntradayFibColour); 
      if (NoOfTrades > 0) AdjustTakeProfit();
   }//if (High[0] > IntradayFibHigh && Ask <= IntradayR1)
   
   //Redraw Intraday following a move to T1 and subsequent retrace, however small
   double IntradayT1 = NormalizeDouble(IntradayFibLow + (FibSize * 134 / 100), Digits);
   if (NewHigh > IntradayT1 && Ask < NewHigh)
   {
      IntradayFibHigh = NewHigh;
      IntradayFibHighTime = NewHighTime; 
      DrawFib(intraday, IntradayFibColour);
   }//if (High[0] > IntradayFibHigh && Ask <= IntradayR1)
   
   double IntradayS1 = NormalizeDouble(IntradayFibLow + (FibSize * 19.1 / 100), Digits);
   double NewLow = iLow(NULL, 1440, 0);
   int	 NewLowTime; 
   if (NewLow < IntradayFibLow && Bid >= IntradayS1)
   {
      IntradayFibLow = GetPreviousLow(NewLow, NewLowTime); //KH MOD
      IntradayFibLowTime = NewLowTime; //KH MOD
      DrawFib(intraday, IntradayFibColour);
   }//if (NewLow < IntradayFibLow && Bid >= IntradayS1)
   
   //Redraw Intraday following a move to T1 and subsequent retrace, however small
   IntradayT1 = NormalizeDouble(IntradayFibLow - (FibSize * 34 / 100), Digits);
   if (NewLow < IntradayT1 && Bid > NewLow)
   {
      IntradayFibLow = NewLow;
      IntradayFibLowTime = NewLowTime; 
      DrawFib(intraday, IntradayFibColour);
   }//if (NewLow < IntradayT1 && Bid > IntradayT1)
   
   ////////////////////////////////////////////////////////////////////
   //Set trend.
   //Market is above Intraday pivot - trend is up; below is down.
   FibSize = IntradayFibHigh - IntradayFibLow;
   IntradayPivot = NormalizeDouble(IntradayFibLow + (FibSize / 2), Digits); 
   //Also cater for a trend flip. The results of doing this are unpredictable
   string OldTrend = Trend;
   Trend = up;
   if (Bid < IntradayPivot) Trend = down;
   if (OldTrend != Trend)
   {
      OldTrend = Trend;
      ResetFiboState( breech, FibObjDel );
   }//if (OldTrend != Trend)
   ////////////////////////////////////////////////////////////////////
   
         
   //////////////////////////////////////////////////////////////////////
   //Draw Breech fib at the start of trading
   if (DrawBreech)
   {
      of = FiboObjectFind(breech); 
      if (of == -1)
      {
         if (TicketNo == 0) CalculateAndDrawBreech(false);//Tells the function the 50% does not have to lead the market
         if (TicketNo > 0) CalculateAndDrawBreech(true);
      }//if (of == -1)
   }//if (DrawBreech)
   //////////////////////////////////////////////////////////////////////
   
   
   if (StopTradingOnceTargetReached)
   {
      bool ProfitTargetHit = IsTargetReached();
      if (ProfitTargetHit)
      {
         Comment("Global profit target has been reached, so the robot has stopped trading. ", NL,
                 "The robot will continue to monitor any open trades for half-close/breakeven opportunities");
         return;        
      }//if (ProfitTargetHit)
      
   }//if (StopTradingOnceTargetReached)
   
   //Htf trend filter
   if (UseRsiTrendFilter)
   {
      GetHtfTrend();      
   }//if (UseRsiTrendFilter)
         
   //////////////////////////////////////////////////////////////////////
   //Send a trade and re-draw the fib following a break of the breech BreechPivot
   if (OldBars != Bars)
   {
      bool TradeAllowed = true;
      static int TradeTries;
      
      //Store no of open trades in NoOfTrades for use in stop loss manipulation
      if (OrdersTotal() != OldOrdersTotal) 
      {
         GetPosition();
         OldOrdersTotal = OrdersTotal();
      }//if (OrdersTotal() != OldOrdersTotal) 
   
      
      //Adjust the Intraday if the market has reached T1
      FibSize = IntradayFibHigh - IntradayFibLow;      
      //New high
      double T1 = NormalizeDouble(IntradayFibLow + (FibSize * 134 / 100), Digits);
      double dHigh =iHigh(NULL, PERIOD_D1, 0);
      if (dHigh >= T1 && Ask < dHigh) 
      {
         ResetFiboState( intraday, FibObjSav );
         IntradayFibHigh = dHigh;
         IntradayFibHighTime = Time[0]; 
         DrawFib(intraday, IntradayFibColour);
      }//if (dHigh > IntradayFibHigh && Ask < dHigh) 
      //New low
      T1 = NormalizeDouble(IntradayFibLow - (FibSize * 34 / 100), Digits);
      double dLow =iLow(NULL, PERIOD_D1, 0);
      if (dLow >= T1 && Bid > dLow) 
      {
         ResetFiboState( intraday, FibObjSav );
         IntradayFibLow = dLow;
         IntradayFibLowTime = Time[0]; 
         SaveGlobalVars( intraday );  
         DrawFib(intraday, IntradayFibColour);
      }//if (dLow > IntradayFibLow && Ask < dLow) 
      //Enusre fib is big enough for trading
      FibSize = IntradayFibHigh - IntradayFibLow;      
      if (FibSize < MinIntradayFibSize * Point) TradeAllowed=false;
         
      OldBars = Bars;
      //Calculate breech BreechPivot
      FibSize = BreechFibHigh - BreechFibLow;      
      BreechPivot = NormalizeDouble(BreechFibLow + (FibSize / 2), Digits); 
         
      
      //Decide trading direction
      FibSize = IntradayFibHigh - IntradayFibLow;
      IntradayPivot = NormalizeDouble(IntradayFibLow + (FibSize / 2), Digits); 
      Trend = up;
      if (Bid < IntradayPivot) Trend = down;
      
      //Downtrend
      double spread = MarketInfo(Symbol(), MODE_SPREAD);
      RefreshRates();
      if (Trend == down && Bid < BreechPivot - (spread * Point) )
      {
         //Htf trend filter
         if (UseRsiTrendFilter)
         {
            if (HtfTrend != down) TradeAllowed = false;
         }//if (UseRsiTrendFilter)
         
         
         //Manual trend setting
         if (SetTrendManually)
         {
            if (TrendIsUp) HtfTrend = up;
            if (TrendIsDown) HtfTrend = down;
            if (TrendIsRanging) HtfTrend = ranging;
            if (HtfTrend != down) TradeAllowed = false;
         }//if (SetTrendManually)
         
         bool CandleBreak = GetBreechPivotCandlesClose(down, BreechPivot);
         if (!CandleBreak) {TradeAllowed = false; return;}
         

         ////////////////////////////////////////
         //Trading code               
         bool TradeSuccess = true;
         //Calculate stop loss and take profit
         FibSize = IntradayFibHigh - IntradayFibLow;
         //StopLoss = NormalizeDouble(IntradayFibLow + (FibSize * 80.9 / 100), Digits);
         StopLoss = NormalizeDouble(BreechFibHigh + (SlPipsFromBreech * Point), Digits);
         //Check maximum stop loss
         if (StopLoss - Bid > MaxStopLoss * Point)
         {
            StopLoss = NormalizeDouble(Bid + (MaxStopLoss * Point), Digits);
         }//if (StopLoss - Bid > MaxStopLoss * Point)
         
         TakeProfit = NormalizeDouble(IntradayFibLow - (FibSize * 34 / 100) + (TakeProfitsPipTolerance * Point), Digits);//T1
         //Check maximum take profit
         if (Bid - TakeProfit > MaxTakeProfit * Point)
         {
            TakeProfit = NormalizeDouble(Bid - (MaxTakeProfit * Point), Digits);
         }//if (Bid - TakeProfit > MaxTakeProfit * Point)

         RefreshRates();
         //Minimum distance from previous trade filter
         double PD = 0;//Pi[sDistance
         if (TicketNo > 0)
         {
            OrderSelect(TicketNo, SELECT_BY_TICKET);
            PD = OrderOpenPrice() - Bid;
            if (PD < (MinPipsBetweenTrades * Point) ) TradeAllowed = false;
         }//if (TicketNo > 0)
               
         if (TradeShort && !AlertNotTrade && TradeAllowed) TradeSuccess = SendSingleTrade(OP_SELL, TradeComment, Lot, Bid, StopLoss, TakeProfit);
         if (AlertNotTrade)
         {
            Alert(Symbol(), " Short trade setup");
            ObjectCreate("DownArrow", OBJ_ARROW, Time[0], Ask, Time[0], Ask);
            ObjectSet("DownArrow", OBJPROP_COLOR, Red);
            ObjectSet("DownArrow", OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
         }//if (AlertNotTrade)
         
         ////////////////////////////////////////
         
         //Reset OldBars if trade-send failed, to force a retry at the next tick
         if (!TradeSuccess)
         {
            OldBars = 0;
            //Limit the number of times the robot will try
            TradeTries++;
            if (TradeTries == 10)
            {
               TradeTries = 0;
               OldBars = Bars;
            }//if (TradeTries == 10)
            
         }//if (!TradeSuccess)
         
         //Stop loss manipulation
         if (TradeSuccess)
         {
            int TradesOpen = NoOfTrades;
            NoOfTrades++;
            TradeTries = 0;
               if (NoOfTrades > 1 && NoOfTrades > TradesOpen)
            {
               ForceSlManipulation = UpdateStopLosses();//Set to false to force a retry if an ordermodify fails
            }//if (NoOfTrades > 1)
            
         }//if (TradeSuccess)
         
         
         //Move breech fib
         if (TradeSuccess && DrawBreech)
         {
            ResetFiboState( breech, FibObjDel );
            CalculateAndDrawBreech(true);//The 50% must lead the market
         }//if (TradeSuccess)
         
      }//if (Trend == down && Bid < BreechPivot && High[1] > BreechPivot)
      
      //Uptrend
      RefreshRates();
      if (Trend == up && Ask > BreechPivot + (spread * Point))
      {
         //Htf trend filter
         if (UseRsiTrendFilter)
         {            
            if (HtfTrend != up) TradeAllowed = false;
         }//if (UseRsiTrendFilter)
         
         
         
         //Manual trend setting
         if (SetTrendManually)
         {
            if (TrendIsUp) HtfTrend = up;
            if (TrendIsDown) HtfTrend = down;
            if (TrendIsRanging) HtfTrend = ranging;
            if (HtfTrend != up) TradeAllowed = false;
         }//if (SetTrendManually)
         
         CandleBreak = GetBreechPivotCandlesClose(up, BreechPivot);
         if (!CandleBreak) {TradeAllowed = false; return;}
         
         ////////////////////////////////////////
         //Trading code 
         TradeSuccess = true;
         //Calculate stop loss and take profit
         FibSize = IntradayFibHigh - IntradayFibLow;
         //StopLoss = NormalizeDouble(IntradayFibLow + (FibSize * 19.1 / 100), Digits);
         StopLoss = NormalizeDouble(BreechFibLow - (SlPipsFromBreech * Point), Digits);
         //Check maximum stop loss
         if (Ask - StopLoss > MaxStopLoss * Point)
         {
            StopLoss = NormalizeDouble(Ask - (MaxStopLoss * Point), Digits);
         }//if (Ask - StopLoss > MaxStopLoss * Point)

         TakeProfit = NormalizeDouble(IntradayFibLow + (FibSize * 134 / 100) - (TakeProfitsPipTolerance * Point), Digits);//T1
         //Check maximum take profit
         if (TakeProfit - Ask > MaxTakeProfit * Point)
         {
            TakeProfit = NormalizeDouble(Ask + (MaxTakeProfit * Point), Digits);
         }//if (Bid - TakeProfit > MaxTakeProfit * Point)


         RefreshRates();
         //Minimum distance from previous trade filter
         PD = 0;//Pi[sDistance
         if (TicketNo > 0)
         {
            OrderSelect(TicketNo, SELECT_BY_TICKET);
            PD = Ask - OrderOpenPrice();
            if (PD < (MinPipsBetweenTrades * Point) ) TradeAllowed = false;
         }//if (TicketNo > 0)
         
         if (TradeLong && !AlertNotTrade && TradeAllowed) TradeSuccess = SendSingleTrade(OP_BUY, TradeComment, Lot, Ask, StopLoss, TakeProfit);
         if (AlertNotTrade)
         {
            Alert(Symbol(), " Long trade setup");
            ObjectCreate("UpArrow", OBJ_ARROW, Time[0], Bid, Time[0], Bid);
            ObjectSet("UpArrow", OBJPROP_COLOR, Green);
            ObjectSet("UpArrow", OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
         }//if (AlertNotTrade)
         
         
         ////////////////////////////////////////
         
         //Reset OldBars if trade-send failed, to force a retry at the next tick
         if (!TradeSuccess)
         {
            OldBars = 0;
            //Limit the number of times the robot will try
            TradeTries++;
            if (TradeTries == 10)
            {
               TradeTries = 0;
               OldBars = Bars;
            }//if (TradeTries == 10)
            
         }//if (!TradeSuccess)
         
         //Stop loss manipulation
         if (TradeSuccess)
         {
            TradesOpen = NoOfTrades;
            NoOfTrades++;
            TradeTries = 0;
            if (NoOfTrades > 1 && NoOfTrades > TradesOpen)
            {
               ForceSlManipulation = UpdateStopLosses();//Set to false to force a retry if an ordermodify fails
            }//if (NoOfTrades > 1)
            
         }//if (TradeSuccess)
         
         //Move breech fib
         if (TradeSuccess && DrawBreech)
         {
            ResetFiboState( breech, FibObjDel );
            CalculateAndDrawBreech(true);//The 50% must lead the market
         }//if (TradeSuccess && DrawBreech)         
         
      }//if (Trend == up && Ask > BreechPivot && Low[1] < BreechPivot)
      
   
   }//if (OldBars != Bars)
   
   
   //////////////////////////////////////////////////////////////////////
   
   
   if (ShowScreenFeedback) DisplayUserFeedback();
   else
   {
      ScreenMessage="";
      ScreenMessage = StringConcatenate(ScreenMessage, Trend, NL);
      if (UseRsiTrendFilter) ScreenMessage = StringConcatenate(ScreenMessage, "Htf trend = ", HtfTrend, NL);
      Comment(ScreenMessage);
   }//else 
      
//----
   return(0);
}
//+------------------------------------------------------------------+5

/*
[quote=grandehombre;3801626]Hi Steve,

I currently use an EA I wrote to manage orders, once I opened them (it does not open orders!).

Its purpose is to make my life less stressful, once an order has reached 10-15 pips. When that happens, I usually go and read a book and let the EA manage it.

Its rules are very simple

    * set a before-profit SL as soon as it detects an order it hasn't processed
    * if the order is in profit

    * move the SL to OpenPrice - x1, if order is +y1 pips in profit
    * move the SL to OpenPrice - x2, if order is +y2 pips in profit
    * move the SL to OpenPrice - x3, if order is +y3 pips in profit
      <blank>
    * if order is +z1 pips in profit, take k1 lots and monitor progress. for every m1 pips that it goes backwards, take another n1 lots.
    * if order is +z2 pips in profit, take k2 lots and monitor progress. for every m2 pips that it goes backwards, take another n2 lots.
    * if order is +z3 pips in profit, take k3 lots and monitor progress. for every m3 pips that it goes backwards, take another n3 lots.


So, here is what all of the above means in plain English.

    * You start the EA in a chart window
    * You open an order.
    * The EA sets SL to -20pips
    * The order goes in profit of x1 pips (say 10). SL is moved to y1 (-10) pips
    * The order goes in profit of x2 pips (say 15). SL is moved to y2 (+1) pips. You are now safe!
    * The order goes in profit of x3 pips (say 25). SL is moved to y2 (+7) pips.
    * The order goes in profit of z1 pips (say 15). You take k1 (0.1) lots and watch out for reversals of m1 pips (say, 6). When that happens, you take n1 (0.1) lots.
    * The order goes in profit of z2 pips (say 25). You take k2 (0.2) lots and watch out for reversals of m2 pips (say, 8). When that happens, you take n2 (0.1) lots.
    * The order goes in profit of z3 pips (say 35). You take k3 (0.2) lots and watch out for reversals of m3 pips (say, 12). When that happens, you take n3 (0.1) lots.


In other words, take an optimistic view. Instead of having a fixed TP, let the order run for as much as possible.

Take a bit of money on the way (at points z1, z2 and z3) but let the order go for it.
If it starts reversing, collect money whenever it reverses by more than the specified number of pips.

All of the numbers above are meant to be user-defined.

I am not advocating that this should be put into Simone, simply offering one view of how orders could be managed. I have seen many more ways of doing it, so you could pick (n)one of the many out there.

I thought that, since you have sooo much spare time in your hands and this forum has been soooooo easy to manage (cough cough choke), you can whip this up in a day! (or whip me out of the forum! )


Cheers,
Nick

ps: Alas, the EA is not in any shape to be made public and will be staying in its closet.[/quote]


*/